package cn.axzo.msg.center.service.dto;

import cn.axzo.msg.center.service.enums.TerminalTypeEnum;
import com.alibaba.fastjson.JSON;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;

/**
 * @author cold_blade
 * @date 2023/10/12
 * @version 1.0
 */
@Setter
@Getter
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class MessageRouterTerminalDTO implements Serializable {

    private static final long serialVersionUID = 4084885624985898305L;

    /**
     * 页面地址 OR API接口地址
     */
    private String url;
    /**
     * 页面地址所属应用端(如果是API接口地址,请忽略改字段值)
     *     WEB: web端页面
     *     MINI_PROGRAM: 安心筑小程序端页面
     *     IOS: 原生IOS端页面
     *     ANDROID: 原生Android端页面
     *     WEB_VIEW: H5页面
     *     WECHAT_MINI_PROGRAM: 微信小程序页面
     */
    private TerminalTypeEnum terminalType;

    public MessageRouterTerminalDTO deepClone() {
        return MessageRouterTerminalDTO.builder()
                .terminalType(this.terminalType)
                .url(this.url)
                .build();
    }

    public boolean isValid() {
        return StringUtils.isNotBlank(url);
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }
}
